Index: trunk/tools/documentation/PyNCplot.css
===================================================================
--- trunk/tools/documentation/PyNCplot.css	(revision 2156)
+++ trunk/tools/documentation/PyNCplot.css	(revision 2245)
@@ -35,4 +35,6 @@
 /* Environments */
 div.codetxt{width:80%;height:10%;text-align:left;text-indent:0px;background-color:rgb(192,192,192);
+  font-size:0.9em;font-family:"Courier New";color:rgb(0,0,0);}
+div.largecodetxt{width:80%;text-align:left;text-indent:0px;background-color:rgb(192,192,192);
   font-size:0.9em;font-family:"Courier New";color:rgb(0,0,0);}
 
Index: trunk/tools/documentation/install.html
===================================================================
--- trunk/tools/documentation/install.html	(revision 2156)
+++ trunk/tools/documentation/install.html	(revision 2245)
@@ -62,15 +62,48 @@
      <LI>Now all the scripts are held in ${HOME}/PyNCplot. It might be desirable to set an environment variable to make life easier:
       <DIV CLASS="codetxt">$ export pyHOME=${HOME}/PyNCplot</DIV>
-      <LI>Finally one need to compile the Fortran modules using the same python to run the scripts. This is done using a standard `Makefile' and the tool <A CLASS="la" HREF="https://docs.scipy.org/doc/numpy-dev/f2py/" TARGET="_blank">f2py</A> to link Fortran compiled codes to python. There are different versions for different LMD/IPSL and French HPC machines. For a standard linux 64-bits machine (debain 9 with gcc compilers) there is one example as `Makefile.llamp'. Take one and specify a series of different variables specifically for the given machine
-          <DIV CLASS="codetxt">
+      <LI>Finally one need to compile the Fortran modules using the same python to run the scripts. This is done using a standard `Makefile' and the tool <A CLASS="la" HREF="https://docs.scipy.org/doc/numpy-dev/f2py/" TARGET="_blank">f2py</A> to link Fortran compiled codes to python. There are different versions for: different CIMA's machines, different LMD/IPSL and French HPC machines. For a standard linux 64-bits machine (debain 9 with gcc compilers) there is one example as `Makefile.llamp'. Take one and specify a series of different variables specifically for the given machine
+          <DIV CLASS="largecodetxt">
             FC 		= gfortran							# Fortran compiler<BR>
             F2PY    = /usr/bin/f2py						# Path to the f2py tool<BR>
+            F2PYF   =           						# Fortran compiler (when system's one is not used)<BR>
             NCLIBFOLD	= /usr/lib/x86_64-linux-gnu		# Path to netcdf libraries<BR>
             NCINCFOLD	= /usr/include					# Path to netcdf includes<BR>
+            NCLIBFFOLD	= /usr/lib/x86_64-linux-gnu		# Path to netcdf-fortran interface libraries<BR>
+            NCINCFFOLD	= /usr/include					# Path to netcdf-fortran interface includes<BR>
+          </DIV>
+        <LI><B>NOTE:</B> One will not be able to compile all the set of programs within an anaconda environment due to problems with anaconda. Installation of netcdf4 colides with installed <A CLASS="la" HREF="https://anaconda.org/matthewharrison/libnetcdff" TARGET="_blank">libnetcdff</A>. When installing it:</LI>
+          <DIV CLASS="largecodetxt">
+           $ conda install netcdf4 <BR>
+             (...) <BR>
+             - netcdf4<BR>
+           The following packages will be downloaded:<BR>
+<BR>
+              package                    |            build<BR>
+              ---------------------------|-----------------<BR>
+              libnetcdf-4.6.1            |       h10edf3e_2         1.3 MB<BR>
+<BR>
+           The following NEW packages will be INSTALLED:<BR>
+<BR>
+              netcdf4:    1.4.2-py27h4b4f87f_0              <BR>  
+<BR>
+           The following packages will be REMOVED:<BR>
+<BR>
+              libnetcdff: 4.4.4-0              matthewharrison<BR>
+<BR>
+           The following packages will be UPDATED:<BR>
+<BR>
+              libnetcdf:  4.4.0-hf6ef953_0     matthewharrison --> 4.6.1-h10edf3e_2
+          </DIV>
+        <LI> Because of that, Makefile is split in two compilation sub-sets
+          <DIV CLASS="codetxt">
+           $ make pymods: compilation of Fortran modules used in the python scripts<BR>
+           $ make NCfortran: compiation of Fortran modules and main programs which require <BR>
+              netCDF-fortran interface: (for: DistriCorrection and trajectories_overlap)<BR>
+           $ make: compiles all components
           </DIV>
         <LI>Then one only needs to link the Makefile and compile</LI>
           <DIV CLASS="codetxt">
           $ ln -s Makefile.[machine].[compiler] ./Makefile<BR>
-          $ make >& run_make.log
+          $ make [OptionalFlags] >& run_make.log
           </DIV>
         <LI>At the end one should have: </LI>